Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_eiv.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_eiv.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_eiv.F90	(revision 2236)
@@ -41,5 +41,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_muscl.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_muscl.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_muscl.F90	(revision 2236)
@@ -40,5 +40,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_muscl2.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_muscl2.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_muscl2.F90	(revision 2236)
@@ -38,5 +38,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_qck.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_qck.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_qck.F90	(revision 2236)
@@ -41,5 +41,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id:  $
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_tvd.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_tvd.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_tvd.F90	(revision 2236)
@@ -47,5 +47,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_ubs.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_ubs.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_ubs.F90	(revision 2236)
@@ -36,5 +36,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt) 
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/trabbc.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/trabbc.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/trabbc.F90	(revision 2236)
@@ -44,5 +44,5 @@
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/trabbl.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/trabbl.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/trabbl.F90	(revision 2236)
@@ -74,5 +74,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/tradmp.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/tradmp.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/tradmp.F90	(revision 2236)
@@ -51,4 +51,6 @@
    LOGICAL, PUBLIC            ::   lk_tradmp = .TRUE.     !: internal damping flag
 #endif
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   strdmp   !: damping salinity trend (psu/s)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   ttrdmp   !: damping temperature trend (Centigrade/s)
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   resto    !: restoring coeff. on T and S (s-1)
    
@@ -67,5 +69,5 @@
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -92,4 +94,5 @@
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       !!
+      REAL(wp) ::   zta, zsa       ! temporary scalars
       INTEGER ::   ji, jj, jk   ! dummy loop indices
       REAL(wp) ::  zta, zsa
@@ -112,4 +115,7 @@
                   tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + zta
                   tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + zsa
+                  ! save the salinity trend (used in asmtrj)
+                  strdmp(ji,jj,jk) = zsa
+                  ttrdmp(ji,jj,jk) = zta
                END DO
             END DO
@@ -123,7 +129,13 @@
                      zta = resto(ji,jj,jk) * ( t_dta(ji,jj,jk) - tsb(ji,jj,jk,jp_tem) )
                      zsa = resto(ji,jj,jk) * ( s_dta(ji,jj,jk) - tsb(ji,jj,jk,jp_sal) )
-                     tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + zta
-                     tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + zsa
+                  ELSE
+                     zta = 0.e0
+                     zsa = 0.e0   
                   ENDIF
+                  tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + zta
+                  tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + zsa
+                  ! save the salinity trend (used in asmtrj)
+                  strdmp(ji,jj,jk) = zsa
+                  ttrdmp(ji,jj,jk) = zta
                END DO
             END DO
@@ -137,7 +149,14 @@
                      zta = resto(ji,jj,jk) * ( t_dta(ji,jj,jk) - tsb(ji,jj,jk,jp_tem) )
                      zsa = resto(ji,jj,jk) * ( s_dta(ji,jj,jk) - tsb(ji,jj,jk,jp_sal) )
-                     tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + zta
-                     tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + zsa
+                  ELSE
+                     zta = 0.e0
+                     zsa = 0.e0   
                   ENDIF
+                  ! add the trends to the general tracer trends
+                  tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + zta
+                  tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + zsa
+                  ! save the salinity trend (used in asmtrj)
+                  strdmp(ji,jj,jk) = zsa
+                  ttrdmp(ji,jj,jk) = zta
                END DO
             END DO
@@ -208,4 +227,6 @@
          &   CALL ctl_stop( 'no temperature and/or salinity data define key_dtatem and key_dtasal' )
 
+      strdmp(:,:,:) = 0.e0       ! internal damping salinity trend (used in asmtrj)
+      ttrdmp(:,:,:) = 0.e0
       !                          ! Damping coefficients initialization
       IF( lzoom ) THEN   ;   CALL dtacof_zoom( resto )
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traldf.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traldf.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traldf.F90	(revision 2236)
@@ -21,4 +21,5 @@
    USE traldf_bilap    ! lateral mixing             (tra_ldf_bilap routine)
    USE traldf_iso      ! lateral mixing               (tra_ldf_iso routine)
+   USE traldf_iso_grif ! lateral mixing          (tra_ldf_iso_grif routine)
    USE traldf_lap      ! lateral mixing               (tra_ldf_lap routine)
    USE trdmod_oce      ! ocean space and time domain
@@ -46,5 +47,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -70,5 +71,10 @@
       SELECT CASE ( nldf )                       ! compute lateral mixing trend and add it to the general trend
       CASE ( 0 )   ;   CALL tra_ldf_lap   ( kt, 'TRA', gtsu, gtsv, tsb, tsa, jpts        )  ! iso-level laplacian
-      CASE ( 1 )   ;   CALL tra_ldf_iso   ( kt, 'TRA', gtsu, gtsv, tsb, tsa, jpts, ahtb0 )  ! rotated laplacian 
+      CASE ( 1 )    
+         IF ( ln_traldf_grif ) THEN
+            CALL tra_ldf_iso_grif    ( kt )           ! Griffies quarter-cell formulation
+         ELSE
+            CALL tra_ldf_iso   ( kt, 'TRA', gtsu, gtsv, tsb, tsa, jpts, ahtb0 )  ! rotated laplacian
+         ENDIF
       CASE ( 2 )   ;   CALL tra_ldf_bilap ( kt, 'TRA', gtsu, gtsv, tsb, tsa, jpts        )  ! iso-level bilaplacian
       CASE ( 3 )   ;   CALL tra_ldf_bilapg( kt, 'TRA',             tsb, tsa, jpts        )  ! s-coord. horizontal bilap.
@@ -78,5 +84,9 @@
          CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' ldf0 - Ta: ', mask1=tmask,               &
          &             tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         CALL tra_ldf_iso   ( kt, 'TRA', gtsu, gtsv, tsb, tsa, jpts, ahtb0 )  
+         IF ( ln_traldf_grif ) THEN
+            CALL tra_ldf_iso_grif    ( kt )
+         ELSE
+            CALL tra_ldf_iso   ( kt, 'TRA', gtsu, gtsv, tsb, tsa, jpts, ahtb0 )  
+         ENDIF
          CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' ldf1 - Ta: ', mask1=tmask,               &
          &             tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
@@ -144,4 +154,5 @@
          WRITE(numout,*) '      horizontal (geopotential)   ln_traldf_hor   = ', ln_traldf_hor
          WRITE(numout,*) '      iso-neutral                 ln_traldf_iso   = ', ln_traldf_iso
+         WRITE(numout,*) '      iso-neutral (Griffies)      ln_traldf_grif  = ', ln_traldf_grif
       ENDIF
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traldf_iso.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traldf_iso.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traldf_iso.F90	(revision 2236)
@@ -45,5 +45,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traldf_iso_grif.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traldf_iso_grif.F90	(revision 2236)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traldf_iso_grif.F90	(revision 2236)
@@ -0,0 +1,202 @@
+MODULE traldf_iso_grif
+   !!==============================================================================
+   !!                   ***  MODULE  traldf_iso_grif  ***
+   !! Ocean active tracers:  horizontal component of the lateral tracer mixing trend
+   !!==============================================================================
+   !! History :   9.0  !  06-10  (C. Harris)
+   !!----------------------------------------------------------------------
+#if   defined key_ldfslp   ||   defined key_esopa
+   !!----------------------------------------------------------------------
+   !!   'key_ldfslp'               slope of the lateral diffusive direction
+   !!----------------------------------------------------------------------
+   !!   tra_ldf_iso_grif  : update the tracer trend with the horizontal 
+   !!                       component of a iso-neutral laplacian operator
+   !!                       and with the vertical part of
+   !!                       the isopycnal or geopotential s-coord. operator 
+   !!                       vector optimization, use k-j-i loops.
+   !!----------------------------------------------------------------------
+
+   USE oce             ! ocean dynamics and active tracers
+   USE dom_oce         ! ocean space and time domain
+   USE ldftra_oce      ! ocean active tracers: lateral physics
+   USE trdmod          ! ocean active tracers trends 
+   USE trdmod_oce      ! ocean variables trends
+   USE zdf_oce         ! ocean vertical physics
+   USE in_out_manager  ! I/O manager
+   USE ldfslp          ! iso-neutral slopes
+   USE diaptr          ! poleward transport diagnostics
+   USE prtctl          ! Print control
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC tra_ldf_iso_grif   ! routine called by traldf.F90
+
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
+#  include "ldftra_substitute.h90"
+#  include "ldfeiv_substitute.h90"
+#  include "vectopt_loop_substitute.h90"
+   !!----------------------------------------------------------------------
+   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE tra_ldf_iso_grif( kt )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE tra_ldf_iso_grif  ***
+      !!
+      !! ** Purpose :   Compute the before horizontal tracer (t & s) diffusive 
+      !!      trend for a laplacian tensor (except the dz[ dz[.] ] term) and 
+      !!      add it to the general trend of tracer equation.
+      !!
+      !! ** Method  :   The horizontal component of the lateral diffusive trends 
+      !!      is provided by a 2nd order operator rotated along neutral or geopo-
+      !!      tential surfaces to which an eddy induced advection can be added
+      !!      It is computed using before fields (forward in time)
+      !!
+      !!      1st part :  masked horizontal derivative of T & S ( di[ t ] )
+      !!      ========    with partial cell update if ln_zps=T.
+      !!
+      !!      2nd part :  horizontal fluxes of the lateral mixing operator
+      !!      ========    
+      !!      take the horizontal divergence of the fluxes:
+      !!         difft = 1/(e1t*e2t*e3t) {  di-1[ zftu ] +  dj-1[ zftv ]  }
+      !!      Add this trend to the general trend (ta,sa):
+      !!         ta = ta + difft
+      !!
+      !!      3rd part: vertical trends of the lateral mixing operator
+      !!      ========  (excluding the vertical flux proportional to dk[t] )
+      !!      vertical fluxes associated with the rotated lateral mixing:
+
+      !!      take the horizontal divergence of the fluxes:
+      !!         difft = 1/(e1t*e2t*e3t) dk[ zftw ]
+      !!      Add this trend to the general trend (ta,sa):
+      !!         ta = ta + difft
+      !!
+      !! ** Action :
+      !!         Update (ta,sa) arrays with the before rotated diffusion trend
+      !!            (except the dk[ dk[.] ] term)
+      !!
+      !!----------------------------------------------------------------------
+      USE oce           , zftv => ua   ! use ua as workspace
+      USE oce           , zfsv => va   ! use va as workspace
+      !!
+      INTEGER, INTENT( in ) ::   kt        ! ocean time-step index
+      !!
+      INTEGER  ::   ji, jj, jk, ip, jp, kp    ! dummy loop indices
+      INTEGER  ::   iku, ikv                  ! temporary integer
+      REAL(wp) ::   zatempu, zdx, zta         ! temporary scalars
+      REAL(wp) ::   zatempv, zdy, zsa         !    "         "
+      REAL(wp) ::   zslopec, zdsloper, zepsln !    "         "
+      REAL(wp) ::   zsxe, za_sxe, zfact       !    "         "
+      REAL(wp) ::   zbtr                      !    "         "
+      REAL(wp), DIMENSION(2) ::   zdelta   ! 1D workspace
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zftu   ! 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zfsu   !    "           "
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zdit, zdjt, zdkt     ! 3D workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zdis, zdjs, zdks     !  "      "
+
+
+
+      !!----------------------------------------------------------------------
+
+      IF( kt == nit000 ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'tra_ldf_iso_grif : rotated laplacian diffusion operator'
+         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~~~'
+      ENDIF
+
+      IF ( .NOT. lk_traldf_eiv ) THEN
+        fsaeiu(:,:,:)=0.0
+        fsaeiv(:,:,:)=0.0
+        fsaeiw(:,:,:)=0.0
+      ENDIF
+
+      DO jk=1,jpkm1
+      DO jj=1,jpjm1
+      DO ji=1,fs_jpim1
+               ftu(ji,jj,jk)=ftud(ji,jj,jk)+ftu(ji,jj,jk)*(fsahtu(ji,jj,jk)-fsaeiu(ji,jj,jk))
+               fsu(ji,jj,jk)=fsud(ji,jj,jk)+fsu(ji,jj,jk)*(fsahtu(ji,jj,jk)-fsaeiu(ji,jj,jk))
+               ftv(ji,jj,jk)=ftvd(ji,jj,jk)+ftv(ji,jj,jk)*(fsahtv(ji,jj,jk)-fsaeiv(ji,jj,jk))
+               fsv(ji,jj,jk)=fsvd(ji,jj,jk)+fsv(ji,jj,jk)*(fsahtv(ji,jj,jk)-fsaeiv(ji,jj,jk))
+      END DO
+      END DO
+      END DO
+
+      DO jk = 1, jpkm1
+
+         ! II.4 Second derivative (divergence) and add to the general trend
+         ! ----------------------------------------------------------------
+         DO jj = 2 , jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               zbtr= 1. / ( e1t(ji,jj)*e2t(ji,jj)*fse3t(ji,jj,jk) )
+               zta = zbtr * ( ftu(ji,jj,jk) - ftu(ji-1,jj,jk) + ftv(ji,jj,jk) - ftv(ji,jj-1,jk)  )
+               zsa = zbtr * ( fsu(ji,jj,jk) - fsu(ji-1,jj,jk) + fsv(ji,jj,jk) - fsv(ji,jj-1,jk)  )
+               ta (ji,jj,jk) = ta (ji,jj,jk) + zta
+               sa (ji,jj,jk) = sa (ji,jj,jk) + zsa
+            END DO
+         END DO
+         !                                          ! ===============
+      END DO                                        !   End of slab  
+      !                                             ! ===============
+
+      IF( ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN   ! Poleward diffusive heat and salt transports
+         pht_ldf(:) = ptr_vj( zftv(:,:,:) )
+         pst_ldf(:) = ptr_vj( zfsv(:,:,:) )
+      ENDIF
+
+      !!----------------------------------------------------------------------
+      !!   III - vertical trend of T & S (extra diagonal terms only)
+      !!----------------------------------------------------------------------
+
+      ! I.5 Divergence of vertical fluxes added to the general tracer trend
+      ! -------------------------------------------------------------------
+
+      DO jk=1,jpk
+      DO jj=2,jpjm1
+      DO ji=fs_2,fs_jpim1
+               tfw(ji,jj,jk)=tfw(ji,jj,jk)*(fsahtw(ji,jj,jk)+fsaeiw(ji,jj,jk))
+               sfw(ji,jj,jk)=sfw(ji,jj,jk)*(fsahtw(ji,jj,jk)+fsaeiw(ji,jj,jk))
+      END DO
+      END DO
+      END DO
+
+      DO jk = 1, jpkm1
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               zbtr =  1. / ( e1t(ji,jj)*e2t(ji,jj)*fse3t(ji,jj,jk) )
+               zta  = (  tfw(ji,jj,jk) - tfw(ji,jj,jk+1)  ) * zbtr
+               zsa  = (  sfw(ji,jj,jk) - sfw(ji,jj,jk+1)  ) * zbtr
+               ta(ji,jj,jk) = ta(ji,jj,jk) + zta
+               sa(ji,jj,jk) = sa(ji,jj,jk) + zsa
+            END DO
+         END DO
+      END DO
+      !
+      DO jk=1,jpk
+      DO jj=2,jpjm1
+      DO ji=fs_2,fs_jpim1
+       psix_eiv(ji,jj,jk) = psix_eiv(ji,jj,jk)*fsaeiu(ji,jj,jk)
+       psiy_eiv(ji,jj,jk) = psiy_eiv(ji,jj,jk)*fsaeiv(ji,jj,jk)
+      END DO
+      END DO
+      END DO
+
+   END SUBROUTINE tra_ldf_iso_grif
+
+#else
+   !!----------------------------------------------------------------------
+   !!   default option :   Dummy code   NO rotation of the diffusive tensor
+   !!----------------------------------------------------------------------
+CONTAINS
+   SUBROUTINE tra_ldf_iso_grif( kt )               ! Empty routine
+      WRITE(*,*) 'tra_ldf_iso_grif: You should not have seen this print! error?', kt
+   END SUBROUTINE tra_ldf_iso_grif
+#endif
+
+   !!==============================================================================
+END MODULE traldf_iso_grif
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/tranpc.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/tranpc.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/tranpc.F90	(revision 2236)
@@ -33,5 +33,5 @@
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/tranxt.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 2236)
@@ -42,6 +42,9 @@
    USE traqsr          ! penetrative solar radiation (needed for nksr)
    USE traswp          ! swap array
+   USE obc_oce 
+#if defined key_agrif
    USE agrif_opa_update
    USE agrif_opa_interp
+#endif
 
    IMPLICIT NONE
@@ -60,5 +63,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traqsr.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 2236)
@@ -59,5 +59,5 @@
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -380,5 +380,5 @@
                ENDIF
                ALLOCATE( sf_chl(1)%fnow(jpi,jpj,1)   )
-               ALLOCATE( sf_chl(1)%fdta(jpi,jpj,1,2) )
+               IF( sn_chl%ln_tint )ALLOCATE( sf_chl(1)%fdta(jpi,jpj,1,2) )
                !                                        ! fill sf_chl with sn_chl and control print
                CALL fld_fill( sf_chl, (/ sn_chl /), cn_dir, 'tra_qsr_init',   &
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/trasbc.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 2236)
@@ -27,4 +27,5 @@
    USE sbcmod          ! ln_rnf  
    USE iom
+   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
 
    IMPLICIT NONE
@@ -39,5 +40,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -107,7 +108,4 @@
       !!
       INTEGER  ::   ji, jj, jk           ! dummy loop indices  
-      REAL(wp) ::   zta, zsa, zrnf       ! local scalars, adjustment to temperature and salinity  
-      REAL(wp) ::   zsrau, zse3t, zdep   ! local scalars, 1/density, 1/height of box, 1/height of effected water column  
-      REAL(wp) ::   zdheat, zdsalt       ! total change of temperature and salinity  
       REAL(wp) ::   zfact, z1_e3t        ! 
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrdt, ztrds
@@ -179,27 +177,5 @@
          END DO
       ENDIF
-                                                   ! Concentration dilution effect on (t,s) due to  
-                                                   ! river runoff without T, S and depth attributes
-      IF( ln_rnf ) THEN 
-         !
-         IF( lk_vvl ) THEN                            ! Variable Volume case 
-            !                                         ! cooling/heating effect of runoff & No salinity concent./dilut. effect
-            DO jj = 2, jpj
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  sbc_hc_n(ji,jj) = sbc_hc_n(ji,jj) + zsrau * rnf(ji,jj) * tsn(ji,jj,1,jp_tem)
-               END DO
-            END DO
-         ELSE                                         ! Constant Volume case
-            !                                         ! concent./dilut. effect only
-            DO jj = 2, jpj 
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  sbc_sc_n(ji,jj) = sbc_sc_n(ji,jj) - zsrau * rnf(ji,jj) * tsn(ji,jj,1,jp_sal)
-               END DO
-            END DO
-         ENDIF
-         !  
-      ENDIF
-      !                                          Add to the general trend
-      !                                          ************************
+      ! Concentration dilution effect on (t,s) due to evapouration, precipitation and qns, but not river runoff  
       DO jj = 2, jpj
          DO ji = fs_2, fs_jpim1   ! vector opt.
@@ -219,62 +195,21 @@
          CALL iom_rstput( kt, nitrst, numrow, 'sbc_sc_b', sbc_sc_n )
       ENDIF
-
-      IF( ln_rnf .AND. ln_rnf_att ) THEN        ! Concentration / dilution effect on (t,s) due to river runoff  
-        !
-        DO jj = 1, jpj  
-           DO ji = 1, jpi  
-              zdep  = 1. / rnf_dep(ji,jj)  
-              zse3t = 1. / fse3t(ji,jj,1)  
-              rnf_dep(ji,jj) = 0.e0
-              DO jk = 1, rnf_mod_dep(ji,jj)                          ! recalculates rnf_dep to be the depth  
-                rnf_dep(ji,jj) = rnf_dep(ji,jj) + fse3t(ji,jj,jk)    ! in metres to the bottom of the relevant grid box  
-              END DO
-              IF( rnf_tmp(ji,jj) == -999 )   rnf_tmp(ji,jj) = tsn(ji,jj,1,jp_tem)   ! if not specified set runoff temp to be sst  
-  
-              IF( rnf(ji,jj) > 0.e0 ) THEN  
-                !
-                zrnf = rnf(ji,jj) * zsrau * zdep
-                IF( lk_vvl ) THEN  
-                  ! indirect flux, concentration or dilution effect : force a dilution effect in all levels 
-                  zdheat = 0.e0  
-                  zdsalt = 0.e0  
-                  DO jk = 1, rnf_mod_dep(ji,jj)  
-                    zta = -tsn(ji,jj,jk,jp_tem) * zrnf  
-                    zsa = -tsn(ji,jj,jk,jp_sal) * zrnf  
-                    tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + zta        ! add the trend to the general tracer trend
-                    tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + zsa
-                    zdheat = zdheat + zta * fse3t(ji,jj,jk)  
-                    zdsalt = zdsalt + zsa * fse3t(ji,jj,jk)  
-                  END DO  
-                  ! negate this total change in heat and salt content from top level    !!gm I don't understand this
-                  tsa(ji,jj,1,jp_tem) = tsa(ji,jj,1,jp_tem) - zdheat * zse3t
-                  tsa(ji,jj,1,jp_sal) = tsa(ji,jj,1,jp_sal) - zdsalt * zse3t
-    
-                  DO jk = 1, rnf_mod_dep(ji,jj)  
-                    tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + rnf_tmp(ji,jj) * zrnf
-                    tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + rnf_sal(ji,jj) * zrnf
-                  END DO  
-                ELSE  
-                  DO jk = 1, rnf_mod_dep(ji,jj)  
-                    tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + ( rnf_tmp(ji,jj) - tsn(ji,jj,jk,jp_tem) ) * zrnf
-                    tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + ( rnf_sal(ji,jj) - tsn(ji,jj,jk,jp_sal) ) * zrnf
-                  END DO  
-                ENDIF  
-  
-              ELSEIF( rnf(ji,jj) < 0.e0 ) THEN   ! for use in baltic when flow is out of domain, want no change in temp and sal  
-  
-                IF( lk_vvl ) THEN  
-                  ! calculate automatic adjustment to sal and temp due to dilution/concentraion effect   
-                  zrnf = rnf(ji,jj) * zsrau * zse3t
-                  tsa(ji,jj,1,jp_tem) = tsa(ji,jj,1,jp_tem) + tsn(ji,jj,1,jp_tem) * zrnf 
-                  tsa(ji,jj,1,jp_sal) = tsa(ji,jj,1,jp_sal) + tsn(ji,jj,1,jp_sal) * zrnf
-                ENDIF  
-  
-              ENDIF  
-  
-           END DO  
-        END DO  
-        !
+      !                             !==  Runoffs  ==!
+      ! Effect on (t,s) due to river runoff (dilution effect automatically applied via vertical tracer advection) 
+      IF( ln_rnf ) THEN  
+         DO jj = 2, jpj 
+            DO ji = fs_2, fs_jpim1
+               zdep = 1. / h_rnf(ji,jj)  
+               IF ( rnf(ji,jj) .ne. 0.0 ) THEN
+                  DO jk = 1, nk_rnf(ji,jj)
+                                        tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + tsc_rnf(ji,jj,jp_tem) * zdep
+                     IF( ln_rnf_sal )   tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + tsc_rnf(ji,jj,jp_sal) * zdep
+                  ENDDO
+               ENDIF
+            ENDDO  
+         ENDDO  
       ENDIF  
+!!gm  It should be useless
+      CALL lbc_lnk( tsa(:,:,:,jp_tem), 'T', 1. )    ;    CALL lbc_lnk( tsa(:,:,:,jp_sal), 'T', 1. )
 
       IF( l_trdtra )   THEN                      ! save the horizontal diffusive trends for further diagnostics
